package de.beyondjava.SimpleClassParser;

import java.util.List;

import de.beyondjava.Beans.Address
import groovy.util.GroovyTestCase;
import static de.beyondjava.SimpleClassParser.RegularExpressions.*

class SimpleClassParserTest extends GroovyTestCase {

	public void testStrings()
	{
		assertEquals("null", '"a"'.replaceAll(STRING3_REGEXP, "null"))
		assertEquals("null", '"{ba}"'.replaceAll(STRING3_REGEXP, "null"))
		assertEquals("null", '"""{ba}"""'.replaceAll(STRING2_REGEXP, "null"))
		assertEquals("null",'"{"'.replaceAll(STRING3_REGEXP, "null"))
	}
	public void testParser()
	{
		SimpleClassParser parser = new SimpleClassParser()
		List<ClassDefinition> classes = parser.parse("src/de/beyondjava/Beans")
		assertEquals(2, classes.size())
		int vars=0
		int meths=0
		classes.each({ClassDefinition c ->
			println "${c.className} contains ${c.variables?.size()} variables and ${c.methods?.size()} methods"
			vars += c.variables?.size()
			meths += c.methods?.size()
		})
		assertEquals(8, vars)
		assertEquals(4, meths)
	}
}
